' Sparrow-Bewegungsmelder
'
' passive Lichtmessung an Led-red, mit vorhandenen Lichtquellen
'
' (Ein Piezo parallel zur Led-green kann, muss aber nicht geschaltet sein.)
' (Um strende Beeinflussung zu vermeiden, sollte PortB.4 nicht genutzt werden.)
'-------------------------------------------------------------------------------
$regfile = "attiny13.dat"
$crystal = 1200000
$hwstack = 16                                  '8
$swstack = 16                                  '4
$framesize = 16                                '4

Green Alias Portb.1 : Red Alias Portb.3
U3 Alias Getadc(3)                             ' B.3, Led rot
Ddrb = &B00010 : Portb = &B10101               ' aux, red, S2, green, S1; pullup fr aux, Sx

Config Adc = Single , Prescaler = Auto , Reference = Avcc : Start Adc
Config Timer0 = Pwm , Compare_b_pwm = Clear_up , Prescale = 1 : Start Timer0       '1,2MHz/512 ~2344Hz

Const Alarm_zeit = 24                          ' Alarm
Const Messdauer = 1                            ' 1ms*64 oder 2ms*64=128ms

Declare Sub Mittelwert

Dim Index As Byte                              '
Dim Adc_rot As Word                            'Adc
Dim Tmpi As Integer
Dim Delta As Integer                           'delta +-?
Dim Green_flag As Byte                         'green on
Dim Delayms As Byte                            ' (ms) = Alarm_zeit * Messdauer(ms) * 64

   Mittelwert                                  'in Adc_rot
Do
   Tmpi = Adc_rot                              'Adc_alt
   Mittelwert                                  'in Adc_rot
   Delta = Tmpi - Adc_rot                      'Differenz zum vorherigen Wert

'Hysterese berechnen: unabhngig von Vcc oder Helligkeit (Autumatik)
   Tmpi = Adc_rot / 32

   If Delta > Tmpi Then Delayms = Alarm_zeit   'nachtriggern
   Tmpi = -tmpi                                'negieren
   If Delta < Tmpi Then Delayms = Alarm_zeit   'nachtriggern

   If Delayms > 0 Then :                       'Wartezeit = Do:Loop-Schleifen
      Pwm0b = 128 :                            'Green = 1 + Piezo
      Delayms = Delayms - 1 :
   Else :
      Pwm0b = 0 :                              'Green = 0 :
   End If
Loop
'-------------------------------------------------------------------------------
Sub Mittelwert :                               'var: Adc_rot, Index, Messdauer
'Aus 64 Adc-Werten der roten Led wird der Mittelwert gebildet.
   Adc_rot = 0                                 'Integral ber 64 Werte
   For Index = 0 To 63 :
      Adc_rot = Adc_rot + U3 :                 '~1V..1,4V -> U3= 190..500
      Waitms Messdauer :                       '*64 (ms)
   Next :
   Adc_rot = Adc_rot / 64                      'Tiefpass
End Sub
'-------------------------------------------------------------------------------